;  **************************
; * -128.2 "SPSHP" 256B *
; *        VERSION 1         *
; *    BY RIDDLE (C) 2017    *
;  **************************
SHIP:EQU 122
HALF:EQU 6
COUNT:EQU 2C0H
SCREEN:EQU 0C000H
SCRHGH:EQU 0C0H
SCRLEN:EQU 30H

ORG 0
START:
LXI H,0F800H
MVI M,2		; BLANK SCREEN
JMP CLS
SETCLR:		; RST 1 -> HL - ADDRESS, C - COLOR
MVI A,1
JMP 0F839H
RAND:
DW 0
NOP
HLFSHP:		; RST 2 -> H - COLUMN, DE - BITMAP
MVI L,SHIP
MVI B,HALF
SCPY0:
LDAX D
MOV M,A
INX D
LDAX D
MOV C,A
RST 1
INX D
INX H
DCR B
JNZ SCPY0
MVI B,HALF
PUSH D
SCPY1:
DCX D
LDAX D
MOV C,A
DCX D
LDAX D
MOV M,A
RST 1
INX H
DCR B
JNZ SCPY1
POP D
RET
CLS:
MVI H,SCRHGH
CLR:
MVI C,0FH
RST 1
MOV M,A
INX H
MVI C,3
RST 1
MOV M,A
INX H
MOV A,H
SUI SCRHGH+SCRLEN
JNZ CLR
MVI H,SCRHGH+8
LXI D,ROCKET
RST 2
INR H
RST 2
LXI H,SCREEN+0A80H	; GET READY TO FIRE
MOV M,L
LXI H,8512H
SHLD SCREEN+077EH
LXI H,0A21H		; SEE BELOW
SHLD SCREEN+0780H
MOV L,A			; 0A00H - DATA START
ISTAR:
MOV M,A
INR L
JNZ ISTAR
LXI B,COUNT
PUSH B
STARS:
MOV E,M
INR L
MOV A,E
ANI 1
RRC
XRA M
MOV M,A
JM STAR3
JNZ STAR1
DCR C
JNZ STAR3
MVI C,COUNT
DCR L
NSTAR:
PUSH H
LHLD RAND
MOV A,L
INR L
ADD M
SHLD RAND
POP H
CPI SHIP
JC NSTAR1
CPI SHIP+HALF+HALF
JC NSTAR
NSTAR1:
MOV E,A
MOV M,E
INR L
MVI A,SCRLEN-1
MOV M,A
STAR1:
ORI SCRHGH
MOV D,A
LDAX D
ORA A
JNZ STAR2
STC
STAR2:
RAL
STAX D
JNC STAR3
DCR D
DCR M
JNZ STAR2
STAR3:
INR L
JNZ STARS
PUSH B
PUSH H
LXI H,SCREEN+077EH
FLAME:
MVI A,0EH
XRI 0EH
STA FLAME+1
MOV C,A
RST 1
INR L
RST 1
INR L
RST 1
INR L
RST 1
FIRE:
LXI H,SCREEN+0A80H
MOV A,M
RAR
MOV M,A
JNC STAR4
INR H
MOV A,H
CPI SCRHGH+SCRLEN
JC FIRE1
MVI A,SCRHGH+0AH
MOV H,A
FIRE1:
MOV M,L
STA FIRE+2
STAR4:
POP H
POP B
XTHL
DCX H
MOV A,H
ORA L
XTHL
JNZ STARS
MVI A,6		; 16-COLOR MODE
OUT 0F8H
JMP STARS
ROCKET:
DB 0F0H,0CH
DB 8CH,0CH
DB 5FH,8
DB 32H,0CH
DB 62H,0CH
DB 80H,8EH
DB 0,0
DB 0,0
DB 0F0H,8
DB 0CH,8
DB 81H,78H
DB 60H,79H
END
